// bprof test / March 2006

int partition(int a[], int l, int r)
{
  int pivot, i, j, t;
  pivot = a[l];
  i = l; j = r+1;
		
  while (1) {
    do ++i; while(a[i] <= pivot && i <= r);
    do --j; while(a[j] > pivot);
    if( i >= j ) break;
    t = a[i]; a[i] = a[j]; a[j] = t;
  }
  t = a[l]; a[l] = a[j]; a[j] = t;
  return j;
}

void quicksort(int a[], int l, int r)
{
  if (l < r) {
    int j = partition( a, l, r);
    quicksort(a, l, j-1);
    quicksort(a, j+1, r);
  }
}

// selection sort - slow

void sort(int a[], int n)
{
  for (int i=n-1; i > 0; --i) {
    int jmax = 0;
    for (int j=1; j < i; ++j) {
      if (a[j] > a[jmax]) jmax = j;
    }
    int t = a[jmax]; a[jmax] = a[i]; a[i] = t;
  }
}


int main()
{
  int N = 1000000;
  int *a = new int[N];
  
  for (int i=0; i < N; ++i) {
    a[i] = i*i;
  }

  //sort(a, N);
  quicksort(a, 0, N-1);  
}
